package com.aitrainer.api.controller

import com.aitrainer.api.ApiApplication
import com.aitrainer.api.repository.ConfigurationRepository
import org.aspectj.lang.JoinPoint
import org.aspectj.lang.annotation.Aspect
import org.aspectj.lang.annotation.Before
import org.aspectj.lang.annotation.Pointcut
import org.slf4j.LoggerFactory
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.stereotype.Component

@Suppress("unused")
@Aspect
@Component
class ControllerAspect {
    private val logger = LoggerFactory.getLogger(ApiApplication::class.simpleName)

    @Autowired
    private lateinit var configurationRepository: ConfigurationRepository
    @Autowired
    private lateinit var properties: ApplicationProperties


    @Before("execution(* com.aitrainer.api.controller.CustomerController.*(..))")
    fun customerControllerAspect(joinPoint: JoinPoint) {
        println("customer controller")
        Singleton.checkDBUpdate(configurationRepository, properties)
    }

    @Before("execution(* com.aitrainer.api.controller.CustomerPropertyController.*(..))")
    fun customerPropertyControllerAspect(joinPoint: JoinPoint) {
        println("customer property  controller")
        Singleton.checkDBUpdate(configurationRepository, properties)
    }

    @Before("execution(* com.aitrainer.api.controller.ExerciseController.*(..))")
    fun exerciseControllerAspect(joinPoint: JoinPoint) {
        println("exercise controller")
        Singleton.checkDBUpdate(configurationRepository, properties)
    }

    @Before("execution(* com.aitrainer.api.controller.ExercisePlanController.*(..))")
    fun exercisePlanControllerAspect(joinPoint: JoinPoint) {
        println("exercise plan controller")
        Singleton.checkDBUpdate(configurationRepository, properties)
    }

    @Before("execution(* com.aitrainer.api.controller.ExercisePlanDetailController.*(..))")
    fun exercisePlanDetailControllerAspect(joinPoint: JoinPoint) {
        println("exercise plan detail controller")
        Singleton.checkDBUpdate(configurationRepository, properties)
    }

    @Before("execution(* com.aitrainer.api.controller.ExerciseTreeController.*(..))")
    fun exerciseTreeControllerAspect(joinPoint: JoinPoint) {
        println("exercise tree controller")
        Singleton.checkDBUpdate(configurationRepository, properties)
    }

    @Before("execution(* com.aitrainer.api.controller.ExerciseTypeController.*(..))")
    fun exerciseTypeControllerAspect(joinPoint: JoinPoint) {
        println("exercise type controller")
        Singleton.checkDBUpdate(configurationRepository, properties)
    }

    @Before("execution(* com.aitrainer.api.controller.ProductController.*(..))")
    fun productControllerAspect(joinPoint: JoinPoint) {
        println("product controller")
        Singleton.checkDBUpdate(configurationRepository, properties)
    }

    @Before("execution(* com.aitrainer.api.controller.ProductTestController.*(..))")
    fun productTestControllerAspect(joinPoint: JoinPoint) {
        println("product test controller")
        Singleton.checkDBUpdate(configurationRepository, properties)
    }

    @Before("execution(* com.aitrainer.api.controller.PropertyController.*(..))")
    fun propertyControllerAspect(joinPoint: JoinPoint) {
        println("property controller")
        Singleton.checkDBUpdate(configurationRepository, properties)
    }

    @Before("execution(* com.aitrainer.api.controller.PurchaseController.*(..))")
    fun purchaseControllerAspect(joinPoint: JoinPoint) {
        println("purchase controller")
        Singleton.checkDBUpdate(configurationRepository, properties)
    }

    @Before("execution(* com.aitrainer.api.controller.ExerciseDeviceController.*(..))")
    fun exerciseDeviceControllerAspect(joinPoint: JoinPoint) {
        println("exerciseDevice controller")
        Singleton.checkDBUpdate(configurationRepository, properties)
    }

}