package com.aitrainer.api.model

import com.google.gson.annotations.Expose
import org.hibernate.annotations.Fetch
import org.hibernate.annotations.FetchMode
import org.springframework.lang.NonNull
import javax.persistence.*

@Entity
data class Sport (
    @Expose @Id  @GeneratedValue(strategy = GenerationType.IDENTITY) @get: NonNull  var sportId: Long = 0,
    @Expose @get: NonNull  var name: String = "",
) {
    @OneToMany(cascade = [(CascadeType.ALL)], fetch = FetchType.EAGER, mappedBy = "sport")
    @Fetch(value = FetchMode.SUBSELECT)
    @Expose val translations: List<SportTranslation> = mutableListOf<SportTranslation>().toList()

}