package com.aitrainer.api.model

import com.google.gson.annotations.Expose
import org.hibernate.annotations.Fetch
import org.hibernate.annotations.FetchMode
import org.springframework.lang.NonNull
import javax.persistence.*
import javax.validation.constraints.NotBlank

@Entity
data class TrainingPlan (
    @Expose @Id  @GeneratedValue(strategy = GenerationType.IDENTITY) @get: NonNull  var trainingPlanId: Long = 0,
    @Expose @get: NotBlank  var name: String = "",
    @Expose var description: String?,
    @Expose @get: NotBlank  var type: String = "",
) {
    @OneToMany(cascade = [(CascadeType.ALL)], fetch = FetchType.EAGER, mappedBy = "trainingPlan")
    @Fetch(value = FetchMode.SUBSELECT)
    @Expose val details: List<TrainingPlanDetail> = mutableListOf<TrainingPlanDetail>().toList()

    @OneToMany(fetch = FetchType.EAGER, mappedBy = "trainingPlan")
    @Fetch(value = FetchMode.SUBSELECT)
    @Expose val translations: List<TrainingPlanTranslation> = mutableListOf<TrainingPlanTranslation>()

}