package com.aitrainer.api.model

import com.fasterxml.jackson.annotation.JsonIgnore
import com.google.gson.annotations.Expose
import javax.persistence.*
import javax.validation.constraints.NotBlank

@Entity
data class TutorialTranslation (
    @Expose @Id @GeneratedValue(strategy = GenerationType.IDENTITY)  val translationId: Long = 0,

    @Expose @get: NotBlank var languageCode: String?,
    @Expose @get: NotBlank var tutorialText: String = "",

    ) {
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    @JoinColumn(name = "tutorialStepId", nullable = false)
    @JsonIgnore
    val tutorialSteps: TutorialSteps? = null
}