package com.aitrainer.api.test


import com.aitrainer.api.controller.ExerciseTreeController
import com.aitrainer.api.model.ExerciseTree
import com.aitrainer.api.repository.ExerciseTreeParentsRepository
import com.aitrainer.api.repository.ExerciseTreeRepository
import org.junit.jupiter.api.Test
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.boot.test.context.SpringBootTest
import org.springframework.http.ResponseEntity
import kotlin.test.assertEquals
import kotlin.test.assertTrue

@SpringBootTest
class ExerciseTreeTest {

    @Autowired
    private lateinit var exerciseTreeRepository: ExerciseTreeRepository

    @Test
    fun testActiveExercises() {
        val exerciseTreeController = ExerciseTreeController(exerciseTreeRepository)
        val responseEntity: ResponseEntity<List<ExerciseTree>> = exerciseTreeController.getAllActiveMenu()
        assertTrue(responseEntity.body!!.isNotEmpty())


        val exerciseTreeItem = responseEntity.body!![0]
        assertEquals(exerciseTreeItem.name, "Cardio")
        assertEquals(responseEntity.body!![1].translations[0].name, "Erő!")
        assertEquals(responseEntity.body!![0].abilities[0].exerciseAbilityId, 3)
        assertEquals(responseEntity.body!![15].name, "Test Center")
        assertEquals(responseEntity.body!![15].description, "Welcome")
        assertEquals(responseEntity.body!![15].translations[0].name, "Tesztközpont")
        assertEquals(responseEntity.body!![15].translations[0].description, "Üdv")
    }
}